// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('faithwalkers', ['ionic', 'ngCordova', 'fw.controllers', 'fw.services'])

    .run(function ($ionicPlatform, $rootScope) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);

            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }
        });

        // use lodash/underscore in views, ng-repeat="x in _.range(3)"
        //$rootScope._ = window._;
    })

    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider

            // setup an abstract state for the tabs directive
            .state('tab', {
                url: '/tab',
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'TabsController'
            })

            // Each tab has its own nav history stack:

            .state('tab.sessions', {
                url: '/sessions',
                views: {
                    'tab-sessions': {
                        templateUrl: 'templates/tab-sessions.html',
                        controller: 'SessionsCtrl'
                    }
                }
            })
            .state('tab.sessions-detail', {
                url: '/sessions/:sessionId',
                views: {
                    'tab-sessions': {
                        templateUrl: 'templates/session-detail.html',
                        controller: 'SessionDetailCtrl'
                    }
                }
            })

            .state('tab.presenters', {
                cache: false,
                url: '/presenters/:id',
                views: {
                    'tab-presenters': {
                        templateUrl: 'templates/tab-presenters.html',
                        controller: 'PresentersCtrl'
                    }
                }
            })

            .state('tab.map', {
                url: '/map',
                views: {
                    'tab-map': {
                        templateUrl: 'templates/tab-map.html',
                        controller: 'MapCtrl'
                    }
                }
            });

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/tab/sessions');

    })

    .constant('$ionicLoadingConfig', {
            templateUrl: 'templates/loading.html',
            animation: 'fade-in',
            showBackdrop: true,
        })

    //make moment lib injectible to use in controllers for date stuff
    //.constant('moment', moment)

    //make lodash/underscore injectible to use in controllers
    //.constant('_', window._);
